<?php
/**
 * Admin Tabs list.
 *
 * @package    Community_Builder
 * @subpackage Admin
 * @copyright  Copyright (c) 2019, Brajesh Singh
 * @license    https://www.gnu.org/licenses/gpl.html GNU Public License
 * @author     Brajesh Singh
 */

// Do not allow direct access over web.
defined( 'ABSPATH' ) || exit;
?>
<!-- Tabs -->
<?php
$active_tab = $this->get_current_tab();
$menu_slug  = $this->menu_slug;
$url        = admin_url( 'themes.php' );
?>

<div class="nav-tab-wrapper">
    <a href="<?php echo add_query_arg( array( 'page' => $menu_slug, 'tab' => 'intro' ), $url ); ?>" class="nav-tab nav-tab-intro <?php echo $active_tab == 'intro' ? 'nav-tab-active' : ''; ?>">
		<?php esc_html_e( 'Getting Started', 'community-builder' ); ?>
    </a>
    <!--
    <a href="<?php echo add_query_arg( array( 'page' => $menu_slug, 'tab' => 'docs' ), $url ); ?>"
       class="nav-tab nav-tab-docs <?php echo $active_tab == 'docs' ? 'nav-tab-active' : ''; ?>">
        <span class="dashicons dashicons-video-alt3"></span> <?php esc_html_e( 'Tutorials', 'community-builder' ); ?>
    </a>
-->
    <a href="<?php echo add_query_arg( array( 'page' => $menu_slug, 'tab' => 'support' ), $url ); ?>" class="nav-tab nav-tab-support <?php echo $active_tab == 'support' ? 'nav-tab-active' : ''; ?>">
		<?php esc_html_e( 'Support', 'community-builder' ); ?>
    </a>
    <a href="<?php echo esc_url( $this->pro_url ); ?>" target="_blank" class="nav-tab nav-tab-pro">
        <span class="dashicons dashicons-star-filled"></span> <?php esc_html_e( 'Get Pro', 'community-builder' ); ?>
    </a>
</div>
