<?php
/**
 * 404- Not found entry.
 *
 * @package    Community_Builder
 * @subpackage Template
 * @copyright  Copyright (c) 2018, Brajesh Singh
 * @license    https://www.gnu.org/licenses/gpl.html GNU Public License
 * @author     Brajesh Singh
 */

// Do not allow direct access over web.
defined( 'ABSPATH' ) || exit;

?>
<article class="article-error-404 clearfix" id="post-error-404">

	<?php do_action( 'cb_before_404_entry' ); ?>

	<?php if ( ! is_404() ) : ?>

		<header class="entry-header entry-header-404">
			<i class="fa fa-user-secret"></i>
		</header>

	<?php endif; ?>

	<div class="clearfix entry-content">

		<p><?php _e( 'Nothing found! We are looking at it and will have it back soon.', 'community-builder' ); ?></p>

		<?php get_search_form(); ?>

	</div><!-- .entry-content -->

	<?php do_action( 'cb_after_404_entry' ); ?>

</article>
