<?php
/**
 * Global Site Footer Bottom(Copyright).
 *
 * @package    Community_Builder
 * @subpackage Template
 * @copyright  Copyright (c) 2018, Brajesh Singh
 * @license    https://www.gnu.org/licenses/gpl.html GNU Public License
 * @author     Brajesh Singh
 */

// Do not allow direct access over web.
defined( 'ABSPATH' ) || exit;

if ( cb_is_site_copyright_enabled() ) :
	?>
	<!-- copyright -->
	<footer id="site-copyright" class="site-copyright">

		<div class="clearfix inner">

			<?php do_action( 'cb_before_theme_credits' ); ?>

			<?php $footer_text = cb_get_footer_copyright(); ?>

			<?php if ( $footer_text ) : ?>
				<p><?php echo $footer_text; // WPCS: XSS ok. ?></p>
			<?php else : ?>
				<p>
					<?php
					/* translators: %1$s: WordPress.org, %2$s: community builder url*/
					printf( __( 'Proudly powered by <a href="%1$s">WordPress</a> & <a href="%2$s" title ="Community Builder, The best responsive WordPress, BuddyPress Theme">Community Builder</a>.', 'community-builder' ), 'http://wordpress.org', 'https://buddydev.com/community-builder/' );
					?>
				</p>
			<?php endif; ?>

			<?php do_action( 'cb_after_theme_credits' ); ?>

		</div><!-- end of /.inner -->

	</footer> <!-- /.site-copyright -->
<?php
endif; // end of copyright section.
